//+------------------------------------------------------------------+
//|                                                      TSIgOLD.mq4 |
//|                                                 Kamil Gazizullin |
//|                                             forexman77@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "Kamil Gazizullin"
#property link      "forexman77@yandex.ru"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Red
#property indicator_color2  Lime
#property indicator_level1 -25           //   #0   
#property indicator_level2 25            //   #1   
#property indicator_level3 0           
//--- input parameters
extern int       Period_MA_1=1;
extern int       p2 =32;
extern int       p3 =5;
extern int       p4 =1;
extern string simvol="XAGUSD";
//--- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
double ExtMapBuffer9[];
double ExtMapBuffer10[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(10);
   SetIndexStyle(0,DRAW_LINE,2,2);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(1,DRAW_LINE,2,2);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexBuffer(7,ExtMapBuffer8);
   SetIndexBuffer(8,ExtMapBuffer9); 
   SetIndexBuffer(9,ExtMapBuffer10);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
   int i,limit1 = MathMin(Bars-counted_bars,Bars-1);
   double mig_p;
   for(i=limit1;i>=0;i--) ExtMapBuffer3[i]=iClose(simvol,PERIOD_CURRENT,i)-iClose(simvol,PERIOD_CURRENT,i+Period_MA_1);
   for(i=limit1;i>=0;i--) ExtMapBuffer4[i]=MathAbs(iClose(simvol,PERIOD_CURRENT,i)-iClose(simvol,PERIOD_CURRENT,i+Period_MA_1));
   for(i=limit1;i>=0;i--) ExtMapBuffer5[i]=iMAOnArray(ExtMapBuffer3,0,p2,0, MODE_EMA,i);
   for(i=limit1;i>=0;i--) ExtMapBuffer6[i]=iMAOnArray(ExtMapBuffer4,0,p2,0, MODE_EMA,i);
   for(i=limit1;i>=0;i--) ExtMapBuffer7[i]=iMAOnArray(ExtMapBuffer5,0,p3,0, MODE_EMA,i);
   for(i=limit1;i>=0;i--) ExtMapBuffer8[i]=iMAOnArray(ExtMapBuffer6,0,p3,0, MODE_EMA,i);
   for(i=limit1;i>=0;i--) ExtMapBuffer9[i]=iMAOnArray(ExtMapBuffer7,0,p4,0, MODE_EMA,i);
   for(i=limit1;i>=0;i--) ExtMapBuffer10[i]=iMAOnArray(ExtMapBuffer8,0,p4,0, MODE_EMA,i);
   for(i=limit1;i>=0;i--){if (ExtMapBuffer10[i]!=0)ExtMapBuffer1[i]=100*ExtMapBuffer9[i]/ExtMapBuffer10[i];} 
   for(i=limit1;i>=0;i--)
   {
   mig_p=ExtMapBuffer1[i]-ExtMapBuffer1[i+1];
   if (mig_p>0){ExtMapBuffer2[i]=ExtMapBuffer1[i];}
   if (mig_p<0){ExtMapBuffer2[i]=0.0;}
   }
   return(0);
  }
//+------------------------------------------------------------------+
